package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ConstantPushInstruction;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.Visitor;

public class LCONST extends Instruction implements ConstantPushInstruction {
  private long value;
  
  LCONST() {}
  
  public LCONST(long l) {
    super((short)9, (short)1);
    if (l == 0L) {
      setOpcode((short)9);
    } else if (l == 1L) {
      setOpcode((short)10);
    } else {
      throw new ClassGenException("LCONST can be used only for 0 and 1: " + l);
    } 
    this.value = l;
  }
  
  public void accept(Visitor v) {
    v.visitPushInstruction(this);
    v.visitStackProducer(this);
    v.visitTypedInstruction(this);
    v.visitConstantPushInstruction(this);
    v.visitLCONST(this);
  }
  
  public Type getType(ConstantPoolGen cp) {
    return Type.LONG;
  }
  
  public Number getValue() {
    return Long.valueOf(this.value);
  }
}
